import { FunctionComponent } from 'react';
import type { ScrollbarMeasurements } from './useScrollbarSize';
/** Params passed to change handler */
export declare type ScrollbarSizeChangeHandlerParams = ScrollbarMeasurements;
/** ScrollbarSize component props */
export interface ScrollbarSizeProps {
    /** Callback fired when the component loads and when the scrollbar size changes */
    onChange: (result: ScrollbarSizeChangeHandlerParams) => void;
}
/** React component to fire an event when the size of the scrollbar changes */
declare const ScrollbarSize: FunctionComponent<ScrollbarSizeProps>;
export default ScrollbarSize;
